define([
	'app',
], function(app) {
	app.controller("restore_cron_enduser",
		["$rootScope", "$scope", "$routeParams", "$location", "$timeout", "$interval", "api", "meta", "lang", "consts", "permissions", "alert", "popup",
			function($rootScope, $scope, $routeParams, $location, $timeout, $interval, api, meta, lang, consts, permissions, alert, popup) {

				$scope.backups = [];
				$scope.selected = {_id:''};
				$scope.files = {};
				
				meta = meta.new("enduser_cron_backups");
				$scope.meta = meta;
				$scope.metaData = meta.getData();

				meta.setSortReverse(false);
				if(!meta.getSortBy()) meta.setSortBy("created");
				if(!meta.getSortDirection()) meta.setSortDirection("desc");
				meta.setPageSizes([10,25,50,100]);
				meta.setPageSize(10);
				meta.setSortFields(["username", "owner"]);
				meta.setTotalItems($scope.backups.length);

				$scope.saveNotes = function (backup, keyEvent) {
					backup.notes = backup.notes.substr(0, 40);
					if(keyEvent && keyEvent.which !== 13) return;
					api.manageBackupNotes({
						data: { _id: backup._id, notes: backup.notes },
						success: function (data, message) { alert.success(message); },
						failed: function (message) { alert.error(message); },
					});
					backup.editing = false;
				};

				$scope.selectedBackup = function(backup) {
					if($scope.selected._id === backup._id) $scope.selected = {_id:''};
					else $scope.selected = backup;
				};

				$scope.prepareSummary = function (type) {
					$scope.showSummary(type, [$scope.selected]);
				};

				$scope.fetch = function () {

					$scope.backups = [];
					$scope.selected = {_id:''};
					
					var apiParams = {
						name: $scope.loggedAccount.username,
						type: consts.BACKUP_TYPE_ACCOUNT,
						contains: consts.BACKUP_TYPE_ACCOUNT_CRON_JOBS,
						account_id: $scope.loggedAccount._id,
						skip: meta.getSkip(),
						limit: meta.getPageSize(),
						filter: meta.getFilter(),
						sort: {},
						find: {}
					};

					apiParams.sort[meta.getSortBy()] = meta.getSortDirectionInt();

					api.listBackupForTypeName({
						data: apiParams,
						success: function (data) {

							meta.setTotalItems(data.total);
							meta.calculate(data.backups);

							for(var i = 0; i < data.backups.length; i++) {

								var names = [];
								for(var j = 0; j < data.backups[i].schedules.length; j++) names.push(consts.SCHEDULE_TYPES[data.backups[i].schedules[j]]);
								data.backups[i].schedules_names = names.join(",");
								$scope.backups.push(data.backups[i]);
							}
						}
					});
				};
				
				$timeout($scope.fetch);
			}
		]
	);
});